## papi 5.6.0

=== doc/Makefile ===
.PHONY:	clean clobber distclean install force_me all

all: man
	@echo "Built PAPI user documentation"

html: force_me
	doxygen Doxyfile-html

man: man/man1 man/man3

man/man3: ../src/papi.h ../src/papi.c ../src/papi_hl.c ../src/papi_fwrappers.c
	doxygen Doxyfile-man3

man/man1: ../src/utils/papi_avail.c ../src/utils/papi_clockres.c  ../src/utils/papi_command_line.c ../src/utils/papi_component_avail.c ../src/utils/papi_cost.c ../src/utils/papi_decode.c ../src/utils/papi_error_codes.c ../src/utils/papi_event_chooser.c ../src/utils/papi_xml_event_info.c ../src/utils/papi_mem_info.c ../src/utils/papi_multiplex_cost.c ../src/utils/papi_native_avail.c  ../src/utils/papi_version.c
	doxygen Doxyfile-man1
 
clean:
	rm -rf man html doxyerror

distclean clobber: clean

install: man
	-rm -f man/man3/HighLevelInfo.3
	-rm -f man/man3/papi_data_structures.3
	-rm -r ../man/man1/*.1 ../man/man3/*.3
	-cp -R man/man1/*.1 ../man/man1
	-cp -R man/man3/*.3 ../man/man3

=== src/libpfm4/lib/Makefile ===
#
# Copyright (c) 2002-2006 Hewlett-Packard Development Company, L.P.
# Contributed by Stephane Eranian <eranian@hpl.hp.com>
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies
# of the Software, and to permit persons to whom the Software is furnished to do so,
# subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED,
# INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
# PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
# HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF
# CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE
# OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
#
TOPDIR  := $(shell if [ "$$PWD" != "" ]; then echo $$PWD; else pwd; fi)/..

include $(TOPDIR)/config.mk
include $(TOPDIR)/rules.mk

#
# Common files
#
SRCS=pfmlib_common.c

ifeq ($(SYS),Linux)
SRCS += pfmlib_perf_event_pmu.c pfmlib_perf_event.c pfmlib_perf_event_raw.c
endif

CFLAGS+=-D_REENTRANT -I. -fvisibility=hidden

#
# list all library support modules
#
ifeq ($(CONFIG_PFMLIB_ARCH_IA64),y)
INCARCH = $(INC_IA64)
#SRCS   += pfmlib_gen_ia64.c pfmlib_itanium.c pfmlib_itanium2.c pfmlib_montecito.c
CFLAGS += -DCONFIG_PFMLIB_ARCH_IA64
endif

ifeq ($(CONFIG_PFMLIB_ARCH_X86),y)

ifeq ($(SYS),Linux)
SRCS += pfmlib_intel_x86_perf_event.c pfmlib_amd64_perf_event.c \
	pfmlib_intel_netburst_perf_event.c \
	pfmlib_intel_snbep_unc_perf_event.c
endif

INCARCH = $(INC_X86)
SRCS   += pfmlib_amd64.c pfmlib_intel_core.c pfmlib_intel_x86.c \
	  pfmlib_intel_x86_arch.c pfmlib_intel_atom.c \
	  pfmlib_intel_nhm_unc.c pfmlib_intel_nhm.c \
	  pfmlib_intel_wsm.c  \
	  pfmlib_intel_snb.c pfmlib_intel_snb_unc.c \
	  pfmlib_intel_ivb.c pfmlib_intel_ivb_unc.c \
	  pfmlib_intel_hsw.c \
	  pfmlib_intel_bdw.c \
	  pfmlib_intel_skl.c \
	  pfmlib_intel_rapl.c \
	  pfmlib_intel_snbep_unc.c \
	  pfmlib_intel_snbep_unc_cbo.c \
	  pfmlib_intel_snbep_unc_ha.c \
	  pfmlib_intel_snbep_unc_imc.c \
	  pfmlib_intel_snbep_unc_pcu.c \
	  pfmlib_intel_snbep_unc_qpi.c \
	  pfmlib_intel_snbep_unc_ubo.c \
	  pfmlib_intel_snbep_unc_r2pcie.c \
	  pfmlib_intel_snbep_unc_r3qpi.c \
	  pfmlib_intel_ivbep_unc_cbo.c \
	  pfmlib_intel_ivbep_unc_ha.c \
	  pfmlib_intel_ivbep_unc_imc.c \
	  pfmlib_intel_ivbep_unc_pcu.c \
	  pfmlib_intel_ivbep_unc_qpi.c \
	  pfmlib_intel_ivbep_unc_ubo.c \
	  pfmlib_intel_ivbep_unc_r2pcie.c \
	  pfmlib_intel_ivbep_unc_r3qpi.c \
	  pfmlib_intel_ivbep_unc_irp.c \
	  pfmlib_intel_hswep_unc_cbo.c \
	  pfmlib_intel_hswep_unc_ha.c \
	  pfmlib_intel_hswep_unc_imc.c \
	  pfmlib_intel_hswep_unc_pcu.c \
	  pfmlib_intel_hswep_unc_qpi.c \
	  pfmlib_intel_hswep_unc_ubo.c \
	  pfmlib_intel_hswep_unc_r2pcie.c \
	  pfmlib_intel_hswep_unc_r3qpi.c \
	  pfmlib_intel_hswep_unc_irp.c \
	  pfmlib_intel_hswep_unc_sbo.c \
	  pfmlib_intel_bdx_unc_cbo.c \
	  pfmlib_intel_bdx_unc_ubo.c \
	  pfmlib_intel_bdx_unc_sbo.c \
	  pfmlib_intel_bdx_unc_ha.c \
	  pfmlib_intel_bdx_unc_imc.c \
	  pfmlib_intel_bdx_unc_irp.c \
	  pfmlib_intel_bdx_unc_pcu.c \
	  pfmlib_intel_bdx_unc_qpi.c \
	  pfmlib_intel_bdx_unc_r2pcie.c \
	  pfmlib_intel_bdx_unc_r3qpi.c \
	  pfmlib_intel_knc.c \
	  pfmlib_intel_slm.c \
	  pfmlib_intel_knl.c \
	  pfmlib_intel_knl_unc_imc.c \
	  pfmlib_intel_knl_unc_edc.c \
	  pfmlib_intel_knl_unc_cha.c \
	  pfmlib_intel_knl_unc_m2pcie.c \
	  pfmlib_intel_glm.c \
	  pfmlib_intel_netburst.c \
	  pfmlib_amd64_k7.c pfmlib_amd64_k8.c pfmlib_amd64_fam10h.c \
	  pfmlib_amd64_fam11h.c pfmlib_amd64_fam12h.c \
	  pfmlib_amd64_fam14h.c pfmlib_amd64_fam15h.c \
	  pfmlib_amd64_fam17h.c pfmlib_amd64_fam16h.c

CFLAGS += -DCONFIG_PFMLIB_ARCH_X86

ifeq ($(CONFIG_PFMLIB_ARCH_I386),y)
SRCS += pfmlib_intel_coreduo.c pfmlib_intel_p6.c
CFLAGS += -DCONFIG_PFMLIB_ARCH_I386
endif

ifeq ($(CONFIG_PFMLIB_ARCH_X86_64),y)
CFLAGS += -DCONFIG_PFMLIB_ARCH_X86_64
endif

endif

ifeq ($(CONFIG_PFMLIB_ARCH_POWERPC),y)

ifeq ($(SYS),Linux)
SRCS += pfmlib_powerpc_perf_event.c
endif

INCARCH = $(INC_POWERPC)
SRCS   += pfmlib_powerpc.c pfmlib_power4.c pfmlib_ppc970.c pfmlib_power5.c pfmlib_power6.c pfmlib_power7.c pfmlib_torrent.c pfmlib_power8.c pfmlib_power9.c pfmlib_powerpc_nest.c
CFLAGS += -DCONFIG_PFMLIB_ARCH_POWERPC
endif

ifeq ($(CONFIG_PFMLIB_ARCH_S390X),y)

ifeq ($(SYS),Linux)
SRCS += pfmlib_s390x_perf_event.c
endif

INCARCH = $(INC_S390X)
SRCS   += pfmlib_s390x_cpumf.c
CFLAGS += -DCONFIG_PFMLIB_ARCH_S390X
endif

ifeq ($(CONFIG_PFMLIB_ARCH_SPARC),y)

ifeq ($(SYS),Linux)
SRCS += pfmlib_sparc_perf_event.c
endif

INCARCH = $(INC_SPARC)
SRCS   += pfmlib_sparc.c pfmlib_sparc_ultra12.c pfmlib_sparc_ultra3.c pfmlib_sparc_ultra4.c pfmlib_sparc_niagara.c
CFLAGS += -DCONFIG_PFMLIB_ARCH_SPARC
endif

ifeq ($(CONFIG_PFMLIB_ARCH_ARM),y)

ifeq ($(SYS),Linux)
SRCS += pfmlib_arm_perf_event.c
endif

INCARCH = $(INC_ARM)
SRCS   += pfmlib_arm.c pfmlib_arm_armv7_pmuv1.c pfmlib_arm_armv6.c pfmlib_arm_armv8.c
CFLAGS += -DCONFIG_PFMLIB_ARCH_ARM
endif

ifeq ($(CONFIG_PFMLIB_ARCH_ARM64),y)

ifeq ($(SYS),Linux)
SRCS += pfmlib_arm_perf_event.c
endif

INCARCH = $(INC_ARM64)
SRCS   += pfmlib_arm.c pfmlib_arm_armv8.c
CFLAGS += -DCONFIG_PFMLIB_ARCH_ARM64
endif

ifeq ($(CONFIG_PFMLIB_ARCH_MIPS),y)

ifeq ($(SYS),Linux)
SRCS += pfmlib_mips_perf_event.c
endif

INCARCH = $(INC_MIPS)
SRCS   += pfmlib_mips.c pfmlib_mips_74k.c
CFLAGS += -DCONFIG_PFMLIB_ARCH_MIPS
endif

ifeq ($(CONFIG_PFMLIB_CELL),y)
INCARCH = $(INC_CELL)
#SRCS   += pfmlib_cell.c
CFLAGS += -DCONFIG_PFMLIB_CELL
endif

ifeq ($(SYS),Linux)
SLDFLAGS=$(LDFLAGS) -shared -Wl,-soname -Wl,$(VLIBPFM)
SLIBPFM=libpfm.so.$(VERSION).$(REVISION).$(AGE)
VLIBPFM=libpfm.so.$(VERSION)
SOLIBEXT=so
endif

CFLAGS+=-I.
ALIBPFM=libpfm.a

TARGETS=$(ALIBPFM)

ifeq ($(CONFIG_PFMLIB_SHARED),y)
TARGETS += $(SLIBPFM)
endif

OBJS=$(SRCS:.c=.o)
SOBJS=$(OBJS:.o=.lo)

INC_COMMON= $(PFMINCDIR)/perfmon/pfmlib.h pfmlib_priv.h

ifeq ($(SYS),Linux)
INC_COMMON += $(PFMINCDIR)/perfmon/perf_event.h events/perf_events.h
endif

INC_IA64=pfmlib_ia64_priv.h	 \
	events/itanium_events.h	 \
	events/itanium2_events.h \
	events/montecito_events.h

INC_X86= pfmlib_intel_x86_priv.h	\
	pfmlib_amd64_priv.h		\
	events/amd64_events_k7.h    	\
	events/amd64_events_k8.h    	\
	events/amd64_events_fam10h.h	\
	events/amd64_events_fam11h.h	\
	events/amd64_events_fam12h.h	\
	events/amd64_events_fam14h.h	\
	events/amd64_events_fam15h.h	\
	events/amd64_events_fam17h.h	\
	events/amd64_events_fam16h.h	\
	events/intel_p6_events.h	\
	events/intel_netburst_events.h	\
	events//intel_x86_arch_events.h \
	events/intel_coreduo_events.h	\
	events/intel_core_events.h	\
	events/intel_atom_events.h	\
	events/intel_nhm_events.h	\
	events/intel_nhm_unc_events.h	\
	events/intel_wsm_events.h	\
	events/intel_wsm_unc_events.h	\
	events/intel_snb_events.h	\
	events/intel_snb_unc_events.h	\
	events/intel_ivb_events.h	\
	events/intel_hsw_events.h	\
	events/intel_bdw_events.h	\
	events/intel_skl_events.h	\
	events/intel_glm_events.h	\
	pfmlib_intel_snbep_unc_priv.h	\
	events/intel_snbep_unc_cbo_events.h \
	events/intel_snbep_unc_ha_events.h \
	events/intel_snbep_unc_imc_events.h \
	events/intel_snbep_unc_pcu_events.h \
	events/intel_snbep_unc_qpi_events.h \
	events/intel_snbep_unc_ubo_events.h \
	events/intel_snbep_unc_r2pcie_events.h \
	events/intel_snbep_unc_r3qpi_events.h \
	events/intel_knc_events.h \
	events/intel_knl_events.h \
	events/intel_ivbep_unc_cbo_events.h \
	events/intel_ivbep_unc_ha_events.h \
	events/intel_ivbep_unc_imc_events.h \
	events/intel_ivbep_unc_pcu_events.h \
	events/intel_ivbep_unc_qpi_events.h \
	events/intel_ivbep_unc_ubo_events.h \
	events/intel_ivbep_unc_r2pcie_events.h \
	events/intel_ivbep_unc_r3qpi_events.h \
	events/intel_ivbep_unc_irp_events.h \
	events/intel_hswep_unc_cbo_events.h \
	events/intel_hswep_unc_sbo_events.h \
	events/intel_hswep_unc_ha_events.h \
	events/intel_hswep_unc_imc_events.h \
	events/intel_hswep_unc_pcu_events.h \
	events/intel_hswep_unc_qpi_events.h \
	events/intel_hswep_unc_ubo_events.h \
	events/intel_hswep_unc_r2pcie_events.h \
	events/intel_hswep_unc_r3qpi_events.h \
	events/intel_hswep_unc_irp_events.h \
	events/intel_bdx_unc_cbo_events.h \
	events/intel_bdx_unc_ubo_events.h \
	events/intel_bdx_unc_sbo_events.h \
	events/intel_bdx_unc_ha_events.h \
	events/intel_bdx_unc_imc_events.h \
	events/intel_bdx_unc_irp_events.h \
	events/intel_bdx_unc_pcu_events.h \
	events/intel_bdx_unc_qpi_events.h \
	events/intel_bdx_unc_r2pcie_events.h \
	events/intel_bdx_unc_r3qpi_events.h \
	events/intel_knl_unc_imc_events.h \
	events/intel_knl_unc_edc_events.h \
	events/intel_knl_unc_cha_events.h \
	events/intel_knl_unc_m2pcie_events.h \
	events/intel_slm_events.h

INC_MIPS=events/mips_74k_events.h events/mips_74k_events.h

INC_POWERPC=events/ppc970_events.h	\
	events/ppc970mp_events.h	\
	events/power4_events.h		\
	events/power5_events.h		\
	events/power5+_events.h		\
	events/power6_events.h		\
	events/power7_events.h		\
	events/power8_events.h		\
	events/power9_events.h		\
	events/torrent_events.h		\
	events/powerpc_nest_events.h

INC_S390X=pfmlib_s390x_priv.h \
	events/s390x_cpumf_events.h

INC_SPARC=events/sparc_ultra12_events.h		\
	events/sparc_ultra3_events.h		\
	events/sparc_ultra3plus_events.h	\
	events/sparc_ultra3i_events.h		\
	events/sparc_ultra4plus_events.h	\
	events/sparc_niagara1_events.h		\
	events/sparc_niagara2_events.h

INC_CELL=events/cell_events.h

INC_ARM=events/arm_cortex_a8_events.h		\
        events/arm_cortex_a9_events.h		\
        events/arm_arm_xgene_events.h

INC_ARM=pfmlib_arm_priv.h			\
	events/arm_cortex_a7_events.h		\
	events/arm_cortex_a8_events.h		\
	events/arm_cortex_a9_events.h		\
	events/arm_cortex_a15_events.h		\
	events/arm_cortex_a57_events.h		\
	events/arm_cortex_a53_events.h

INC_ARM64=events/arm_cortex_a57_events.h	\
	  events/arm_cortex_a53_events.h

INCDEP=$(INC_COMMON) $(INCARCH)

all: $(TARGETS)

$(OBJS) $(SOBJS): $(TOPDIR)/config.mk $(TOPDIR)/rules.mk Makefile $(INCDEP)

libpfm.a:  $(OBJS)
	$(RM) $@
	$(AR) cq $@ $(OBJS)

$(SLIBPFM):  $(SOBJS)
	$(CC) $(CFLAGS) $(SLDFLAGS)  -o $@ $(SOBJS)
	$(LN) $@ $(VLIBPFM)
	$(LN) $@ libpfm.$(SOLIBEXT)

clean:
	$(RM) -f *.o *.lo *.a *.so* *~ *.$(SOLIBEXT)

distclean: clean

depend:
	$(MKDEP) $(CFLAGS) $(SRCS)

install: $(TARGETS)

install:
	@echo building: $(TARGETS)
	-mkdir -p $(DESTDIR)$(LIBDIR)
	$(INSTALL) -m 644 $(ALIBPFM) $(DESTDIR)$(LIBDIR)
ifeq ($(CONFIG_PFMLIB_SHARED),y)
	$(INSTALL) $(SLIBPFM) $(DESTDIR)$(LIBDIR)
	cd $(DESTDIR)$(LIBDIR); $(LN) $(SLIBPFM) $(VLIBPFM)
	cd $(DESTDIR)$(LIBDIR); $(LN) $(SLIBPFM) libpfm.$(SOLIBEXT)
	-$(LDCONFIG)
endif

tags:
	$(CTAGS) -o $(TOPDIR)/tags --tag-relative=yes $(SRCS) $(INCDEP)

=== src/components/appio/tests/Makefile ===
NAME=appio
include ../../Makefile_comp_tests.target

%.o:%.c
	$(CC) $(CFLAGS) $(OPTFLAGS) $(INCLUDE) -c -o $@ $<

TESTS = appio_list_events appio_values_by_code appio_values_by_name appio_test_read_write appio_test_pthreads appio_test_fread_fwrite appio_test_seek

ALL_TESTS = $(TESTS) appio_test_blocking appio_test_select appio_test_recv appio_test_socket

appio_tests: $(TESTS)

all: $(ALL_TESTS)

ARCH=$(shell uname -m)

ifeq (x86_64,$(ARCH))
        ARCH_SUFFIX="-AMD64"
endif


%.o:%.c
	$(CC) $(CFLAGS) $(OPTFLAGS) $(INCLUDE) -c -o $@ $<

appio_list_events: appio_list_events.o $(UTILOBJS) $(PAPILIB)
	$(CC) $(CFLAGS) $(INCLUDE) -o $@ appio_list_events.o $(UTILOBJS) $(PAPILIB) $(LDFLAGS)

appio_values_by_code: appio_values_by_code.o $(UTILOBJS) $(PAPILIB)
	$(CC) $(CFLAGS) $(INCLUDE) -o $@ appio_values_by_code.o $(UTILOBJS) $(PAPILIB) $(LDFLAGS)

appio_values_by_name: appio_values_by_name.o $(UTILOBJS) $(PAPILIB)
	$(CC) $(CFLAGS) $(INCLUDE) -o $@ appio_values_by_name.o $(UTILOBJS) $(PAPILIB) $(LDFLAGS)

appio_test_read_write: appio_test_read_write.o $(UTILOBJS) $(PAPILIB)
	$(CC) $(CFLAGS) $(INCLUDE) -o $@ appio_test_read_write.o $(UTILOBJS) $(PAPILIB) $(LDFLAGS)

appio_test_seek: appio_test_seek.o $(UTILOBJS) $(PAPILIB)
	$(CC) $(CFLAGS) $(INCLUDE) -o $@ appio_test_seek.o $(UTILOBJS) $(PAPILIB) $(LDFLAGS)

appio_test_blocking: appio_test_blocking.o $(UTILOBJS) $(PAPILIB)
	$(CC) $(CFLAGS) $(INCLUDE) -o $@ appio_test_blocking.o $(UTILOBJS) $(PAPILIB) $(LDFLAGS)

appio_test_socket: appio_test_socket.o $(UTILOBJS) $(PAPILIB)
	$(CC) $(CFLAGS) $(INCLUDE) -o $@ appio_test_socket.o $(UTILOBJS) $(PAPILIB) $(LDFLAGS)

appio_test_recv: appio_test_recv.o $(UTILOBJS) ../../../libpapi.so
	$(CC) $(CFLAGS) $(INCLUDE) -o $@ appio_test_recv.o $(UTILOBJS) -Wl,-rpath ../../..  ../../../libpapi.so $(LDFLAGS)

appio_test_select: appio_test_select.o $(UTILOBJS) $(PAPILIB)
	$(CC) $(CFLAGS) $(INCLUDE) -o $@ appio_test_select.o $(UTILOBJS) $(PAPILIB) $(LDFLAGS)

appio_test_fread_fwrite: appio_test_fread_fwrite.o $(UTILOBJS) $(PAPILIB)
	$(CC) $(CFLAGS) $(INCLUDE) -o $@ appio_test_fread_fwrite.o $(UTILOBJS) $(PAPILIB) $(LDFLAGS)

appio_test_pthreads: appio_test_pthreads.o $(UTILOBJS) $(PAPILIB)
	$(CC) $(CFLAGS) $(INCLUDE) -o $@ appio_test_pthreads.o $(UTILOBJS) $(PAPILIB) $(LDFLAGS) -lpthread

iozone/iozone_linux$(ARCH_SUFFIX).o iozone/libasync.o iozone/libbif.o: 
	cd iozone; $(MAKE) iozone_linux$(ARCH_SUFFIX).o libasync.o libbif.o

init_fini.o: init_fini.c
	$(CC) $(CFLAGS) $(INCLUDE) -o $@ -c $^

# to test, try:
# ./appio_test_iozone -s 100m -r 64 -i 0 -i 1 -t 1
appio_test_iozone: iozone/iozone_linux$(ARCH_SUFFIX).o iozone/libasync.o iozone/libbif.o init_fini.o $(UTILOBJS) $(PAPILIB)
	$(CC) -g -O2 -o $@ $(LDFLAGS) $^ -lpthread -lrt

clean:
	rm -f $(ALL_TESTS) appio_test_iozone *.o

=== src/components/perf_event_uncore/tests/Makefile ===
NAME=perf_event_uncore
include ../../Makefile_comp_tests.target

%.o:%.c
	$(CC) $(CFLAGS) $(OPTFLAGS) $(INCLUDE) -c -o $@ $<

TESTS = perf_event_uncore perf_event_uncore_attach perf_event_uncore_multiple \
	perf_event_amd_northbridge perf_event_uncore_cbox

DOLOOPS= $(testlibdir)/do_loops.o

perf_event_uncore_tests: $(TESTS)


perf_event_uncore_lib.o:	perf_event_uncore_lib.c perf_event_uncore_lib.h
	$(CC) $(CFLAGS) $(INCLUDE) -c perf_event_uncore_lib.c


perf_event_amd_northbridge:	perf_event_amd_northbridge.o $(DOLOOPS) $(UTILOBJS) $(PAPILIB) $(DOLOOPS)
	$(CC) $(LFLAGS) -o perf_event_amd_northbridge perf_event_amd_northbridge.o $(UTILOBJS) $(DOLOOPS) $(PAPILIB) $(LDFLAGS)

perf_event_uncore:	perf_event_uncore.o $(UTILOBJS) $(DOLOOPS) $(PAPILIB) perf_event_uncore_lib.o
	$(CC) $(LFLAGS) -o perf_event_uncore perf_event_uncore.o perf_event_uncore_lib.o $(UTILOBJS) $(DOLOOPS) $(PAPILIB) $(LDFLAGS)

perf_event_uncore_attach:	perf_event_uncore_attach.o $(UTILOBJS) $(DOLOOPS) $(PAPILIB) perf_event_uncore_lib.o
	$(CC) $(LFLAGS) -o perf_event_uncore_attach perf_event_uncore_attach.o perf_event_uncore_lib.o $(UTILOBJS) $(DOLOOPS) $(PAPILIB) $(LDFLAGS)

perf_event_uncore_multiple:	perf_event_uncore_multiple.o perf_event_uncore_lib.o $(UTILOBJS) $(DOLOOPS) $(PAPILIB)
	$(CC) $(LFLAGS) $(INCLUDE) -o perf_event_uncore_multiple perf_event_uncore_multiple.o perf_event_uncore_lib.o $(UTILOBJS) $(DOLOOPS) $(PAPILIB) $(LDFLAGS) 

perf_event_uncore_cbox:	perf_event_uncore_cbox.o perf_event_uncore_lib.o $(UTILOBJS) $(DOLOOPS) $(PAPILIB)
	$(CC) $(LFLAGS) $(INCLUDE) -o perf_event_uncore_cbox perf_event_uncore_cbox.o perf_event_uncore_lib.o $(UTILOBJS) $(DOLOOPS) $(PAPILIB) $(LDFLAGS)



clean:
	rm -f $(TESTS) *.o *~

=== src/perfctr-2.7.x/examples/global/Makefile ===
# $Id: Makefile,v 1.9 2005/03/23 02:02:54 mikpe Exp $

SHELL=/bin/sh
ARCH := $(shell uname -m | sed -e s/i.86/i386/ -e s/sun4u/sparc64/ -e s/arm.*/arm/ -e s/sa110/arm/)
CC=gcc
CFLAGS=-O2 -fomit-frame-pointer -Wall
CPPFLAGS=-I../../linux/include -I../../usr.lib
HDEP=../../usr.lib/libperfctr.h ../../linux/include/linux/perfctr.h ../../linux/include/asm/perfctr.h arch.h
TARGET=global
i386_OBJS=x86.o
x86_64_OBJS=x86.o
ppc_OBJS=ppc.o
ppc64_OBJS=ppc64.o
ARCH_OBJS=$($(ARCH)_OBJS)
OBJS=global.o $(ARCH_OBJS)

default: $(TARGET)

$(TARGET): $(OBJS) ../../usr.lib/libperfctr.a

$(OBJS): $(HDEP)

install:

distclean realclean:	clean

clean:
	rm -f $(TARGET) $(OBJS) core a.out

=== debian/changelog ===
papi (5.6.0-1) unstable; urgency=medium

  * New upstream release.
  * Cherry-pick upstream buildsystem fix.
  * Refresh patches.
  * Bump libpfm4-dev B-D to >= 4.9.0.
  * Relax the libpfm4 runtime dependency.
  * Update symbols for 5.6.0.
  * Switch to Priority: optional.
  * Bump Standards-Version to 4.1.3.
  * Switch to debhelper compat level 11.
  * Set Rules-Requires-Root: no.
  * Switch from dh_install --list-missing to dh_missing.
  * Ship new examples in papi-examples. Note: The Makefiles shipped in the
    papi-examples package are currently broken.
  * Switch Vcs-* URLs to salsa.debian.org.
  * Mark libpapi-dev as Multi-Arch: same.

 -- Andreas Beckmann <anbe@debian.org>  Thu, 25 Jan 2018 21:34:32 +0100

papi (5.5.1-2) unstable; urgency=medium

  * Remove PIE workarounds, this now works out-of-the-box.
  * Bump libpfm4-dev B-D to >= 4.8.0+git16, which has reverted an unintended
    ABI change.

 -- Andreas Beckmann <anbe@debian.org>  Wed, 03 May 2017 00:43:27 +0200

=== debian/control ===
Source: papi
Section: devel
Priority: optional
Maintainer: Vincent Danjean <vdanjean@debian.org>
Uploaders:
 Andreas Beckmann <anbe@debian.org>
Build-Depends:
 debhelper (>= 11~),
 libpfm4-dev (>= 4.9.0),
 gfortran,
Rules-Requires-Root: no
Standards-Version: 4.1.3
Homepage: https://icl.utk.edu/papi/software/index.html
Vcs-Browser: https://salsa.debian.org/debian/papi
Vcs-Git: https://salsa.debian.org/debian/papi.git

Package: libpapi5
Section: libs
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends:
 ${shlibs:Depends}, ${misc:Depends}
Breaks: libpapi5.3
Replaces: libpapi5.3
Description: PAPI runtime (shared libraries)
 Performance Application Programming Interface (PAPI) provides the tool
 designer and application engineer with a consistent interface and methodology
 for use of the performance counter hardware found in most major
 microprocessors. PAPI enables software engineers to see, in near real time,
 the relation between software performance and processor events.
 .
 In addition Component PAPI provides access to a collection of components that
 expose performance measurement opportunites across the hardware and software
 stack.
 .
 Accessing performance counters from userspace may require reducing the paranoia
 level in /proc/sys/kernel/perf_event_paranoid, see README.Debian for details.
 .
 This package provides the shared library.

Package: libpapi-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
 libpapi5 (= ${binary:Version}),
 ${misc:Depends}
Description: PAPI development files (headers and API documentation)
 Performance Application Programming Interface (PAPI) provides the tool
 designer and application engineer with a consistent interface and methodology
 for use of the performance counter hardware found in most major
 microprocessors. PAPI enables software engineers to see, in near real time,
 the relation between software performance and processor events.
 .
 In addition Component PAPI provides access to a collection of components that
 expose performance measurement opportunites across the hardware and software
 stack.
 .
 This package provides the development files of PAPI.

Package: papi-tools
Architecture: any
Multi-Arch: foreign
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: PAPI utilities
 Performance Application Programming Interface (PAPI) provides the tool
 designer and application engineer with a consistent interface and methodology
 for use of the performance counter hardware found in most major
 microprocessors. PAPI enables software engineers to see, in near real time,
 the relation between software performance and processor events.
 .
 In addition Component PAPI provides access to a collection of components that
 expose performance measurement opportunites across the hardware and software
 stack.
 .
 This package provides utilities provided by the PAPI software.

Package: papi-examples
Architecture: all
Multi-Arch: foreign
Pre-Depends: ${misc:Pre-Depends}
Depends: libpapi-dev (>= ${source:Version}), libpapi-dev (<< ${source:Upstream-Version}.~), ${misc:Depends}
Recommends:
 build-essential,
 gfortran,
 mpi-default-dev,
Description: PAPI example files and test programs
 Performance Application Programming Interface (PAPI) provides the tool
 designer and application engineer with a consistent interface and methodology
 for use of the performance counter hardware found in most major
 microprocessors. PAPI enables software engineers to see, in near real time,
 the relation between software performance and processor events.
 .
 In addition Component PAPI provides access to a collection of components that
 expose performance measurement opportunites across the hardware and software
 stack.
 .
 This package provides examples and tests of the PAPI software.

=== debian/rules ===
#!/usr/bin/make -f
# See debhelper(7) (uncomment to enable)
# output every command that modifies files on the build system.
#export DH_VERBOSE = 1

# see FEATURE AREAS in dpkg-buildflags(1)
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

DPKG_EXPORT_BUILDFLAGS	 = yes
include /usr/share/dpkg/buildflags.mk
include /usr/share/dpkg/architecture.mk

# Upstream does not use CPPFLAGS
CFLAGS	+= $(CPPFLAGS)

%:
	dh $@ --sourcedirectory=src

override_dh_auto_configure:
	dh_auto_configure --sourcedirectory=src -- \
		--with-static-lib=yes \
		--with-shared-lib=yes \
		--with-shlib-tools \
		--with-perf-events \
		--with-pfm-incdir=/usr/include \
		--with-pfm-libdir=/usr/lib/$(DEB_HOST_MULTIARCH) \
		CC=$(CC)
	# for reproducibility
	sed -r -i '/^[CF]FLAGS/s/-fdebug-prefix-map=\S*\s*//' \
		src/ctests/Makefile.target \
		src/ftests/Makefile.target \
		src/testlib/Makefile.target \
		src/validation_tests/Makefile.target \
		src/components/Makefile_comp_tests.target

override_dh_auto_test:
	-env LD_LIBRARY_PATH=$(CURDIR)/src:$(LD_LIBRARY_PATH) dh_auto_test

override_dh_auto_install:
	dh_auto_install --sourcedirectory=src -- install-all
	# delete example binaries
	find debian/tmp/usr/share/papi -perm -100 -type f -delete
	find debian/tmp/usr/share/papi -name \*.a -type f -delete

override_dh_makeshlibs:
	dh_makeshlibs -a -- -c4

override_dh_shlibdeps:
	dh_shlibdeps -a -- --warnings=7

override_dh_missing:
	dh_missing --list-missing

override_dh_installchangelogs:
	dh_installchangelogs RELEASENOTES.txt

override_dh_compress:
	dh_compress -X.c -X.h -X.F -XMakefile

=== debian/watch ===
version=3

https://icl.utk.edu/papi/software/index.html .*/papi-(.*)\.tar\.gz

## papi 5.6.0+git46

=== src/components/cuda/tests/Makefile ===
NAME=cuda
include ../../Makefile_comp_tests.target

CUDA_DIR ?= /opt/cuda
CUPTI_DIR ?= $(CUDA_DIR)/extras/CUPTI
CUDRV_DIR ?= $(CUDA_DIR)

TESTS = HelloWorld simpleMultiGPU simpleMultiGPU_no_counters 
cuda_tests: $(TESTS) 

CUDA_DIR ?= $(CUDA_PATH)
NVCC = $(CUDA_DIR)/bin/nvcc 
NVCFLAGS = -g -ccbin='$(CC)'
INCLUDE += -I$(CUDA_DIR)/include -I$(CUPTI_DIR)/include 
CUDALIBS = -L$(CUDRV_DIR)/lib64 -L$(CUDA_DIR)/lib64 -L$(CUDA_DIR)/lib64/stubs -L$(CUPTI_DIR)/lib64 -lcudart -lcupti -lcuda 
PAPILIB += -L../../../libpfm4/lib -lpfm
default: $(TESTS)

%.o:%.cu
	$(NVCC) $(INCLUDE) $(NVCFLAGS) -c -o $@ $<

HelloWorld: HelloWorld.o $(UTILOBJS)
	$(NVCC) $(NVCFLAGS) -o HelloWorld HelloWorld.o $(UTILOBJS) $(PAPILIB) $(CUDALIBS) $(LDFLAGS)

simpleMultiGPU: simpleMultiGPU.cu $(UTILOBJS)
	$(NVCC) $(NVCFLAGS) $(INCLUDE) -DPAPI -g -o $@ $+ $(UTILOBJS) $(PAPILIB) $(CUDALIBS) $(LDFLAGS)

simpleMultiGPU_no_counters: simpleMultiGPU.cu $(UTILOBJS)
	$(NVCC) $(NVCFLAGS) $(INCLUDE) -DNO_COUNTERS -g -o $@ $+ $(UTILOBJS) $(PAPILIB) $(CUDALIBS) $(LDFLAGS)

simpleMultiGPU_cupti_only: simpleMultiGPU.cu $(UTILOBJS)
	$(NVCC) $(NVCFLAGS) $(INCLUDE) -DCUPTI_ONLY -g -o $@ $+ $(UTILOBJS) $(PAPILIB) $(CUDALIBS) $(LDFLAGS)

clean:
	rm -f $(TESTS) *.o cuda_ld_preload_example.so

# Extra example to show LD_PRELOAD can be used to insert PAPI CUDA into a pre-existing binary
cuda_ld_preload_example.so: simpleMultiGPU_no_counters cuda_ld_preload_example.c
	gcc -Wall -fPIC -shared -o cuda_ld_preload_example.so $(LDFLAGS) $(INCLUDE) cuda_ld_preload_example.c ../../../libpapi.so

run: 
	( cd ~/icl/papi/papi/src/ && make )
	( make HelloWorld )
	./HelloWorld
	( cd ~/icl/papi/papi/src/ && make )
	( make simpleMultiGPU )
	./simpleMultiGPU

## papi 5.6.0+git46-g81b76bd4

=== debian/changelog ===
papi (5.6.0+git46-g81b76bd4-1) unstable; urgency=medium

  * New upstream GIT snapshot.
  * Bump libpfm4-dev B-D to >= 4.10.
  * papi-examples: Fix libpapi-dev dependency upper bound on snapshots.
    (Closes: #898547)
  * Bump Standards-Version to 4.1.5. No changes needed.

 -- Andreas Beckmann <anbe@debian.org>  Tue, 24 Jul 2018 19:09:38 +0200

papi (5.6.0+git22-g4c23d555-1) unstable; urgency=medium

  * New upstream GIT snapshot.
  * Bump libpfm4-dev B-D to >= 4.9.0+git21.
  * Bump Standards-Version to 4.1.4. No changes needed.
  * Add debian/upstream/metadata.
  * Put package under Debian HPC Team maintenance.
  * Add some buildsystem patches.

 -- Andreas Beckmann <anbe@debian.org>  Tue, 24 Apr 2018 02:44:43 +0200

=== debian/control ===
--- 
+++ 
@@ -1,18 +1,19 @@
 Source: papi
 Section: devel
 Priority: optional
-Maintainer: Vincent Danjean <vdanjean@debian.org>
+Maintainer: Debian HPC Team <debian-hpc@lists.debian.org>
 Uploaders:
+ Vincent Danjean <vdanjean@debian.org>,
  Andreas Beckmann <anbe@debian.org>
 Build-Depends:
  debhelper (>= 11~),
- libpfm4-dev (>= 4.9.0),
+ libpfm4-dev (>= 4.10),
  gfortran,
 Rules-Requires-Root: no
-Standards-Version: 4.1.3
+Standards-Version: 4.1.5
 Homepage: https://icl.utk.edu/papi/software/index.html
-Vcs-Browser: https://salsa.debian.org/debian/papi
-Vcs-Git: https://salsa.debian.org/debian/papi.git
+Vcs-Browser: https://salsa.debian.org/hpc-team/papi
+Vcs-Git: https://salsa.debian.org/hpc-team/papi.git
 
 Package: libpapi5
 Section: libs
@@ -81,7 +82,10 @@
 Architecture: all
 Multi-Arch: foreign
 Pre-Depends: ${misc:Pre-Depends}
-Depends: libpapi-dev (>= ${source:Version}), libpapi-dev (<< ${source:Upstream-Version}.~), ${misc:Depends}
+Depends:
+ libpapi-dev (>= ${source:Version}),
+ libpapi-dev (<< ${source:Upstream-Version}.~-~),
+ ${misc:Depends}
 Recommends:
  build-essential,
  gfortran,

## papi 5.6.0+git99

=== src/components/nvml/tests/Makefile ===
NAME=nvml
include ../../Makefile_comp_tests
include ../Makefile.nvml
# -fverbose-asm -Wa,-adhln=benchSANVML.s

NVCC = $(CUDA_DIR)/bin/nvcc
NVCFLAGS = -L$(NVML_INCDIR) -ccbin=$(CC)
CUDALIBS = -L$(NVML_LIBDIR) -L$(CUDA_DIR)/lib64 -lcuda -lcudart -lnvidia-ml
PAPILIB := ../../../libpapi.a  -ldl

%.o:%.cu
	$(NVCC) $(NVCFLAGS) $(INCLUDE) -c -o $@ $<

TESTS = HelloWorld nvml_power_limiting_test

nvml_tests: $(TESTS) 

HelloWorld: HelloWorld.o $(UTILOBJS) 
	$(NVCC) $(NVCFLAGS) $(INCLUDE) -o HelloWorld HelloWorld.o $(UTILOBJS) $(PAPILIB) $(CUDALIBS)

nvml_power_limiting_test: nvml_power_limiting_test.o $(UTILOBJS) 
	$(NVCC) $(NVCFLAGS) $(INCLUDE) -o nvml_power_limiting_test nvml_power_limiting_test.o $(UTILOBJS) $(PAPILIB) $(CUDALIBS)
	cp nvml_power_limiting_test ~/nvml_power_limiting_test

nvml_power_limit_read_test: nvml_power_limit_read_test.o $(UTILOBJS) 
	$(NVCC) $(NVCFLAGS) $(INCLUDE) -o nvml_power_limit_read_test nvml_power_limit_read_test.o $(UTILOBJS) $(PAPILIB) $(CUDALIBS)
	cp nvml_power_limit_read_test ~/nvml_power_limit_read_test

benchSANVML: benchSANVML.o $(UTILOBJS) 
	$(NVCC) $(NVCFLAGS) $(INCLUDE) -o benchSANVML benchSANVML.o $(UTILOBJS) $(PAPILIB) $(CUDALIBS) 


nvmlcap_plot: nvmlcap_plot.o $(UTILOBJS) 
	$(NVCC) $(NVCFLAGS) $(INCLUDE) -o nvmlcap_plot nvmlcap_plot.o $(UTILOBJS) $(PAPILIB) $(CUDALIBS)


clean:
	rm -f $(TESTS) *.o
	rm -f benchSANVML
	rm -f nvmlcap_plot results*

FORCE:

## papi 5.6.0+git99-gd5a1a9ae2

=== debian/changelog ===
papi (5.6.0+git99-gd5a1a9ae2-1) unstable; urgency=medium

  * New upstream GIT snapshot.
  * Refresh patches.
  * Bump libpfm4-dev B-D to >= 4.10.1+git6.
  * Add Build-Depends-Package to symbols file.
  * Switch to debhelper-compat (= 12).
  * Bump Standards-Version to 4.3.0. No changes needed.
  * fix-typos.patch: New, fix more typos found by Lintian.

 -- Andreas Beckmann <anbe@debian.org>  Fri, 25 Jan 2019 23:41:13 +0100

=== debian/control ===
--- 
+++ 
@@ -6,11 +6,11 @@
  Vincent Danjean <vdanjean@debian.org>,
  Andreas Beckmann <anbe@debian.org>
 Build-Depends:
- debhelper (>= 11~),
- libpfm4-dev (>= 4.10),
+ debhelper-compat (= 12),
+ libpfm4-dev (>= 4.10.1+git6),
  gfortran,
 Rules-Requires-Root: no
-Standards-Version: 4.1.5
+Standards-Version: 4.3.0
 Homepage: https://icl.utk.edu/papi/software/index.html
 Vcs-Browser: https://salsa.debian.org/hpc-team/papi
 Vcs-Git: https://salsa.debian.org/hpc-team/papi.git

## papi 5.7.0%2Bdfsg

=== src/components/powercap/tests/Makefile ===
NAME=powercap
include ../../Makefile_comp_tests.target

TESTS = powercap_basic powercap_limit

powercap_tests: $(TESTS)

powercap_basic.o:	powercap_basic.c
	$(CC) $(CFLAGS) $(OPTFLAGS) $(INCLUDE) -c powercap_basic.c -o powercap_basic.o -DBASIC_TEST=1

powercap_basic: powercap_basic.o $(UTILOBJS) $(PAPILIB)
	$(CC) $(INCLUDE) -o powercap_basic powercap_basic.o $(UTILOBJS) $(PAPILIB) $(LDFLAGS) 


powercap_limit.o:	powercap_limit.c
	$(CC) $(CFLAGS) $(OPTFLAGS) $(INCLUDE) -c powercap_limit.c -o powercap_limit.o

powercap_limit: powercap_limit.o $(UTILOBJS) $(PAPILIB)
	$(CC) $(INCLUDE) -o powercap_limit powercap_limit.o $(UTILOBJS) $(PAPILIB) $(LDFLAGS)

clean:
	rm -f $(TESTS) *.o *~

=== debian/rules ===
--- 
+++ 
@@ -2,6 +2,8 @@
 # See debhelper(7) (uncomment to enable)
 # output every command that modifies files on the build system.
 #export DH_VERBOSE = 1
+
+SOVERSION	 = 5.7
 
 # see FEATURE AREAS in dpkg-buildflags(1)
 export DEB_BUILD_MAINT_OPTIONS = hardening=+all
@@ -42,6 +44,8 @@
 	# delete example binaries
 	find debian/tmp/usr/share/papi -perm -100 -type f -delete
 	find debian/tmp/usr/share/papi -name \*.a -type f -delete
+	find debian/tmp/usr/share/papi -name Makefile -type f -print0 | \
+		xargs -0r sed -i -e 's@ [^ ]*-f\(file\|debug\)-prefix-map=[^ ]*@@g'
 
 override_dh_makeshlibs:
 	dh_makeshlibs -a -- -c4
@@ -57,3 +61,21 @@
 
 override_dh_compress:
 	dh_compress -X.c -X.h -X.F -XMakefile
+
+override_dh_gencontrol:
+	dh_gencontrol -- \
+		-V'papi:SOVERSION=$(SOVERSION)'
+
+
+TEMPLATES	:= $(wildcard debian/libpapiSOVERSION.*)
+GENERATED	 = $(subst SOVERSION,$(SOVERSION),$(TEMPLATES))
+
+libpapi$(SOVERSION).%: libpapiSOVERSION.%
+	sed 's/@SOVERSION@/$(SOVERSION)/g' $< > $@
+
+build-generated: $(GENERATED) ;
+clean-generated:
+	$(RM) $(GENERATED)
+
+override_dh_auto_configure: build-generated
+clean: clean-generated

=== debian/watch ===
version=4

opts="dversionmangle=s/\+dfsg\d*$//,repacksuffix=+dfsg" \
https://icl.utk.edu/papi/software/index.html .*/papi-(.*)\.tar\.gz

## papi 5.7.0+dfsg

=== src/examples/Makefile ===
PAPIINC = ..
PAPILIB = ../libpapi.a
CC = gcc
CFLAGS += -I$(PAPIINC)
OS = $(shell uname)

TARGETS_NTHD = PAPI_set_domain sprofile multiplex PAPI_state PAPI_reset PAPI_profil PAPI_perror PAPI_get_virt_cyc PAPI_get_real_cyc PAPI_get_opt PAPI_hw_info PAPI_get_executable_info PAPI_ipc PAPI_flops PAPI_flips PAPI_overflow PAPI_add_remove_event high_level PAPI_add_remove_events

TARGETS_PTHREAD = locks_pthreads overflow_pthreads 

ifeq ($(OS), SunOS)
   LDFLAGS =  $(PAPILIB) -lcpc
   LDFLAGS_PTHREAD =  $(PAPILIB) -lpthread -lcpc
   TARGETS = $(TARGETS_NTHD) $(TARGETS_PTHREAD) 
else 
 ifeq ($(OS), AIX)
   CC = xlc
   LDFLAGS =  $(PAPILIB) -lpmapi
   LDFLAGS_PTHREAD =  $(PAPILIB) -lpthread -lpmapi
   TARGETS = $(TARGETS_NTHD) $(TARGETS_PTHREAD) 
 else
    ifeq ($(OS), OSF1)
        LDFLAGS =  $(PAPILIB) -lrt
        LDFLAGS_PTHREAD =  $(PAPILIB) -lpthread -lrt
        TARGETS = $(TARGETS_NTHD)  
    else
        ifeq ($(OS), Linux)
             TARGETS = $(TARGETS_NTHD) $(TARGETS_PTHREAD) 
        else
             TARGETS = $(TARGETS_NTHD)  
        endif
        LDFLAGS += $(PAPILIB)
        LDFLAGS_PTHREAD = $(LDFLAGS) -lpthread
    endif
 endif
endif

all: $(TARGETS) 

$(TARGETS_NTHD):  %:%.o 
	$(CC) -o $@ $(CFLAGS) $^  $(LDFLAGS)

$(TARGETS_PTHREAD):  %:%.o 
	$(CC) -o $@ $(CFLAGS) $^  $(LDFLAGS_PTHREAD)
clean:
	$(RM) *.o $(TARGETS)

=== src/utils/Makefile ===
# File: utils/Makefile
include Makefile.target

INCLUDE = -I../testlib -I.. -I.
testlibdir=../testlib
CLOCKCORE= $(testlibdir)/clockcore.o
DOLOOPS = $(testlibdir)/do_loops.o

ALL = papi_avail papi_mem_info papi_cost papi_clockres papi_native_avail \
	papi_command_line papi_event_chooser papi_decode papi_xml_event_info \
	papi_version papi_multiplex_cost papi_component_avail papi_error_codes

%.o:%.c
	$(CC) $(CFLAGS) $(OPTFLAGS) $(INCLUDE) -c $<

default all utils: $(ALL)

papi_avail: papi_avail.o $(PAPILIB) print_header.o
	$(CC) $(LDFLAGS) -o papi_avail papi_avail.o print_header.o $(PAPILIB)

papi_clockres: papi_clockres.o $(PAPILIB) $(CLOCKCORE)
	$(CC) $(LDFLAGS) -o papi_clockres papi_clockres.o $(PAPILIB) $(CLOCKCORE) -lm

papi_command_line: papi_command_line.o $(PAPILIB) $(DOLOOPS)
	$(CC) $(LDFLAGS) -o papi_command_line papi_command_line.o $(PAPILIB) $(DOLOOPS)

papi_component_avail: papi_component_avail.o $(PAPILIB) print_header.o
	$(CC) $(LDFLAGS) -o papi_component_avail papi_component_avail.o $(PAPILIB) print_header.o

papi_cost: papi_cost.o $(PAPILIB) cost_utils.o
	$(CC) $(LDFLAGS) -o papi_cost papi_cost.o cost_utils.o $(PAPILIB) -lm

papi_decode: papi_decode.o $(PAPILIB)
	$(CC) $(LDFLAGS) -o papi_decode papi_decode.o $(PAPILIB)

papi_error_codes: papi_error_codes.o $(PAPILIB)
	$(CC) $(LDFLAGS) -o papi_error_codes papi_error_codes.o $(PAPILIB)

papi_event_chooser: papi_event_chooser.o $(PAPILIB) print_header.o
	$(CC) $(LDFLAGS) -o papi_event_chooser papi_event_chooser.o print_header.o $(PAPILIB)

papi_hybrid_native_avail: papi_hybrid_native_avail.o $(PAPILIB)
	$(CC) $(LDFLAGS) -o papi_hybrid_native_avail papi_hybrid_native_avail.o $(PAPILIB)

papi_mem_info: papi_mem_info.o $(PAPILIB)
	$(CC) $(LDFLAGS) -o papi_mem_info papi_mem_info.o $(PAPILIB)

papi_multiplex_cost: papi_multiplex_cost.o $(PAPILIB) cost_utils.o
	$(CC) $(LDFLAGS) -o papi_multiplex_cost papi_multiplex_cost.o cost_utils.o $(PAPILIB) -lm

papi_native_avail: papi_native_avail.o $(PAPILIB) print_header.o
	$(CC) $(LDFLAGS) -o papi_native_avail papi_native_avail.o $(PAPILIB) print_header.o

papi_version: papi_version.o $(PAPILIB)
	$(CC) $(LDFLAGS) -o papi_version papi_version.o $(PAPILIB)

papi_xml_event_info: papi_xml_event_info.o $(PAPILIB)
	$(CC) $(LDFLAGS) -o papi_xml_event_info papi_xml_event_info.o $(PAPILIB)



cost_utils.o: ../testlib/papi_test.h cost_utils.c
	$(CC) $(INCLUDE) $(CFLAGS) $(OPTFLAGS) -c cost_utils.c

print_header.o: print_header.h print_header.c
	$(CC) $(INCLUDE) $(CFLAGS) $(OPTFLAGS) -c print_header.c

clean:
	rm -f *.o *.stderr *.stdout core *~ $(ALL)

distclean clobber: clean
	rm -f Makefile.target

install: $(UTIL_TARGETS)
	@echo "Utilities (BINDIR) being installed in: \"$(BINDIR)\"";
	-mkdir -p $(BINDIR)
	-chmod go+rx $(BINDIR)
	-find . -perm -100 -type f -exec cp {} $(BINDIR) \;

=== src/components/appio/tests/Makefile ===
--- 
+++ 
@@ -56,7 +56,7 @@
 	$(CC) $(CFLAGS) $(INCLUDE) -o $@ appio_test_pthreads.o $(UTILOBJS) $(PAPILIB) $(LDFLAGS) -lpthread
 
 iozone/iozone_linux$(ARCH_SUFFIX).o iozone/libasync.o iozone/libbif.o: 
-	cd iozone; $(MAKE) iozone_linux$(ARCH_SUFFIX).o libasync.o libbif.o
+	$(MAKE) -C iozone iozone_linux$(ARCH_SUFFIX).o libasync.o libbif.o
 
 init_fini.o: init_fini.c
 	$(CC) $(CFLAGS) $(INCLUDE) -o $@ -c $^

=== src/components/cuda/sampling/Makefile ===
# include ../Makefile.cuda

CUDA_DIR ?= /opt/cuda
CUPTI_DIR ?= $(CUDA_DIR)/extras/CUPTI
CFG = -I$(CUDA_DIR)/include  -I$(CUPTI_DIR)/include
LDG = -L$(CUDA_DIR)/lib64 -L$(CUDA_DIR)/lib64/stubs  -L$(CUPTI_DIR)/lib64
NVCC = $(CUDA_DIR)/bin/nvcc

all:
	@make lib
	@make papi_sampling
	@make sample
	@make cpy

lib: activity.c
	@gcc -fPIC -shared -o libactivity.so  $(CFG) $(LDG) activity.c -lcuda -lcupti

papi_sampling: gpu_activity.c
	@echo 'char* ld_prld="LD_PRELOAD='`pwd`'/sampling/libactivity.so";' > path.h
	@gcc -I. gpu_activity.c -o ../../../utils/papi_sampling_cuda

sample: test/matmul.cu
	@$(NVCC) test/matmul.cu $(CFG) $(LDG) -o test/matmul -lcuda 

cpy:
	cp ../../../utils/papi_sampling_cuda  test

clean:
	rm libactivity.so ../../../utils/papi_sampling_cuda test/matmul test/sass* test/papi_sampling_cuda

=== src/components/cuda/tests/Makefile ===
--- 
+++ 
@@ -19,6 +19,9 @@
 %.o:%.cu
 	$(NVCC) $(INCLUDE) $(NVCFLAGS) -c -o $@ $<
 
+%.mac:%.cu
+	$(NVCC) $(INCLUDE) $(NVCFLAGS) -E -c -o $@ $<
+
 HelloWorld: HelloWorld.o $(UTILOBJS)
 	$(NVCC) $(NVCFLAGS) -o HelloWorld HelloWorld.o $(UTILOBJS) $(PAPILIB) $(CUDALIBS) $(LDFLAGS)
 
@@ -31,8 +34,38 @@
 simpleMultiGPU_cupti_only: simpleMultiGPU.cu $(UTILOBJS)
 	$(NVCC) $(NVCFLAGS) $(INCLUDE) -DCUPTI_ONLY -g -o $@ $+ $(UTILOBJS) $(PAPILIB) $(CUDALIBS) $(LDFLAGS)
 
+nvlink_bandwidth: nvlink_bandwidth.cu $(UTILOBJS)
+	$(NVCC) $(NVCFLAGS) $(INCLUDE) -DPAPI -g -o $@ $+ $(UTILOBJS) $(PAPILIB) $(CUDALIBS) $(LDFLAGS)
+
+nvlink_bw_plus: nvlink_bw_plus.cu $(UTILOBJS)
+	$(NVCC) $(NVCFLAGS) $(INCLUDE) -DPAPI -g -o $@ $+ $(UTILOBJS) $(PAPILIB) $(CUDALIBS) $(LDFLAGS)
+
+cuda_event_only_test: cuda_event_only_test.cu $(UTILOBJS)
+	$(NVCC) $(NVCFLAGS) $(INCLUDE) -DPAPI -g -o $@ $+ $(UTILOBJS) $(PAPILIB) $(CUDALIBS) $(LDFLAGS)
+
+cudaTest_cupti_only: cudaTest_cupti_only.cu $(UTILOBJS)
+	$(NVCC) $(NVCFLAGS) $(INCLUDE) -DPAPI -g -o $@ $+ $(UTILOBJS) $(PAPILIB) $(CUDALIBS) $(LDFLAGS)
+
+likeComp_cupti_only: likeComp_cupti_only.cu $(UTILOBJS)
+	$(NVCC) $(NVCFLAGS) $(INCLUDE) -DPAPI -g -o $@ $+ $(UTILOBJS) $(PAPILIB) $(CUDALIBS) $(LDFLAGS)
+
+nvlink_all: nvlink_all.cu $(UTILOBJS)
+	$(NVCC) $(NVCFLAGS) $(INCLUDE) -DPAPI -g -o $@ $+ $(UTILOBJS) $(PAPILIB) $(CUDALIBS) $(LDFLAGS)
+
+nvlink_bandwidth_cupti_only: nvlink_bandwidth_cupti_only.cu $(UTILOBJS)
+	$(NVCC) $(NVCFLAGS) $(INCLUDE) -DPAPI -g -o $@ $+ $(UTILOBJS) $(PAPILIB) $(CUDALIBS) $(LDFLAGS)
+
+# The following program is taken from the cuda sample directory; /sw/peak/cuda/9.2.148/samples/1_Utilities/
+nvidia_sample_bw_test: nvidia_sample_bw_test.cu $(UTILOBJS)
+	$(NVCC) $(NVCFLAGS) $(INCLUDE) -I./sample_inc -DPAPI -g -o $@ $+ $(UTILOBJS) $(PAPILIB) $(CUDALIBS) $(LDFLAGS)
+
+# The following program is taken from the cuda sample directory; /sw/peak/cuda/9.2.148/samples/1_Utilities/
+p2pBandwidthLatencyTest: p2pBandwidthLatencyTest.cu $(UTILOBJS)
+	$(NVCC) $(NVCFLAGS) $(INCLUDE) -I./sample_inc -DPAPI -g -o $@ $+ $(UTILOBJS) $(PAPILIB) $(CUDALIBS) $(LDFLAGS)
+
 clean:
-	rm -f $(TESTS) *.o cuda_ld_preload_example.so
+	rm -f $(TESTS) *.o cuda_ld_preload_example.so nvlink_bandwidth nvlink_all
+
 
 # Extra example to show LD_PRELOAD can be used to insert PAPI CUDA into a pre-existing binary
 cuda_ld_preload_example.so: simpleMultiGPU_no_counters cuda_ld_preload_example.c

=== src/components/mx/tests/Makefile ===
NAME=mx
include ../../Makefile_comp_tests.target

%.o:%.c
	$(CC) $(CFLAGS) $(OPTFLAGS) $(INCLUDE) -c -o $@ $<

TESTS = mx_basic mx_elapsed

mx_tests: $(TESTS)

mx_basic: mx_basic.o $(UTILOBJS) $(PAPILIB)
	$(CC) $(CFLAGS) $(INCLUDE) -o mx_basic mx_basic.o $(UTILOBJS) $(PAPILIB) $(LDFLAGS) 


mx_elapsed: mx_elapsed.o $(UTILOBJS) $(PAPILIB)
	$(CC) $(CFLAGS) $(INCLUDE) -o mx_elapsed mx_elapsed.o $(UTILOBJS) $(PAPILIB) $(LDFLAGS) 


clean:
	rm -f $(TESTS) *.o

=== src/components/nvml/tests/Makefile ===
--- 
+++ 
@@ -5,7 +5,7 @@
 
 NVCC = $(CUDA_DIR)/bin/nvcc
 NVCFLAGS = -L$(NVML_INCDIR) -ccbin=$(CC)
-CUDALIBS = -L$(NVML_LIBDIR) -L$(CUDA_DIR)/lib64 -lcuda -lcudart -lnvidia-ml
+CUDALIBS = -L$(NVML_LIBDIR) -L$(CUDA_DIR)/lib64 -lcuda -lcudart -lnvidia-ml -lstdc++
 PAPILIB := ../../../libpapi.a  -ldl
 
 %.o:%.cu
@@ -16,7 +16,7 @@
 nvml_tests: $(TESTS) 
 
 HelloWorld: HelloWorld.o $(UTILOBJS) 
-	$(NVCC) $(NVCFLAGS) $(INCLUDE) -o HelloWorld HelloWorld.o $(UTILOBJS) $(PAPILIB) $(CUDALIBS)
+	$(NVCC) $(NVCFLAGS) $(INCLUDE) -o HelloWorld HelloWorld.o $(UTILOBJS) $(PAPILIB) $(CUDALIBS) 
 
 nvml_power_limiting_test: nvml_power_limiting_test.o $(UTILOBJS) 
 	$(NVCC) $(NVCFLAGS) $(INCLUDE) -o nvml_power_limiting_test nvml_power_limiting_test.o $(UTILOBJS) $(PAPILIB) $(CUDALIBS)

=== debian/changelog ===
papi (5.7.0+dfsg-2) unstable; urgency=medium

  * Upload to unstable.

 -- Andreas Beckmann <anbe@debian.org>  Sun, 16 Jun 2019 02:01:29 +0200

papi (5.7.0+dfsg-1) experimental; urgency=medium

  * Repack upstream tarball to remove src/components/appio/tests/iozone/*
    which does not permit distribution of derivative works.  (Closes: #928959)
  * Remove unused convenience copies from repacked tarball.
  * Update debian/copyright.
  * Restore support for changing the SOVERSION frequently.
  * Change SONAME to libpapi.so.5.7.  (Closes: #928367)
  * Bump libpfm4-dev B-D to >= 4.10.1+git7.
  * Upload to experimental.

 -- Andreas Beckmann <anbe@debian.org>  Sun, 09 Jun 2019 15:45:21 +0200

papi (5.7.0-1) unstable; urgency=medium

  * New upstream release.
  * Refresh patches.
  * Make the build reproducible, thanks to Chris Lamb.  (Closes: #920594)

 -- Andreas Beckmann <anbe@debian.org>  Thu, 07 Mar 2019 10:59:29 +0100

=== debian/control ===
--- 
+++ 
@@ -7,7 +7,7 @@
  Andreas Beckmann <anbe@debian.org>
 Build-Depends:
  debhelper-compat (= 12),
- libpfm4-dev (>= 4.10.1+git6),
+ libpfm4-dev (>= 4.10.1+git7),
  gfortran,
 Rules-Requires-Root: no
 Standards-Version: 4.3.0
@@ -15,15 +15,17 @@
 Vcs-Browser: https://salsa.debian.org/hpc-team/papi
 Vcs-Git: https://salsa.debian.org/hpc-team/papi.git
 
-Package: libpapi5
+Package: libpapi5.7
 Section: libs
 Architecture: any
 Multi-Arch: same
 Pre-Depends: ${misc:Pre-Depends}
 Depends:
  ${shlibs:Depends}, ${misc:Depends}
-Breaks: libpapi5.3
-Replaces: libpapi5.3
+Breaks:
+ libpapi5 (>= 5.7),
+Replaces:
+ libpapi5 (>= 5.7),
 Description: PAPI runtime (shared libraries)
  Performance Application Programming Interface (PAPI) provides the tool
  designer and application engineer with a consistent interface and methodology
@@ -45,7 +47,7 @@
 Architecture: any
 Multi-Arch: same
 Depends:
- libpapi5 (= ${binary:Version}),
+ libpapi${papi:SOVERSION} (= ${binary:Version}),
  ${misc:Depends}
 Description: PAPI development files (headers and API documentation)
  Performance Application Programming Interface (PAPI) provides the tool
